
; Public Domain

%include "lmacros3.mac"
%include "eld.mac"
%include "eldcall.mac"
%include "elddata.mac"

	addsection RELOCATEDDATA, nobits vstart=8000h
relocateddata:

	addsection HEADER, start=0

		; ELD executable header
	istruc ELD_HEADER
at eldhSignature,	db "ELD0"
			db 0,0,0
			db 26
at eldhCodeOffset,	dd CODEOFFSET
at eldhCodeImageLength,	dw code_size
at eldhCodeAllocLength,	dw 0
at eldhDataOffset,	dd DATAOFFSET
at eldhDataImageLength,	dw data_size
at eldhDataAllocLength,	dw total_data_size - data_size
at eldhCodeEntrypoint,	dw linker - code
at eldhReserved
	iend


	align 16, db 0

CODEOFFSET equ $ - $$
	addsection CODE, follows=HEADER vstart=0
%define CODEFIXUP - code + 0
code:
		; ELD instance header
	istruc ELD_INSTANCE
at eldiStartCode
at eldiEndCode
at eldiStartData
at eldiEndData
at eldiIdentifier,	fill 8, 32, db "LDMEM"
	iend

start:

	push ss
	pop es
	mov si, table
internaldatarelocation
	mov dx, table_sorted
internaldatarelocation

loopprepare:
	lodsw
	test ax, ax
	jz .done
	lodsw
	test ax, ax
	jnz @F
	add si, 4
	jmp .next

@@:
	xchg bx, ax
	mov ax, [bx]
	mov di, table_sorted + 4
internaldatarelocation
@@:
	cmp di, dx
	jae .insert_at_di_minus_4
	scasw
	jb .insert_at_di_minus_6
	add di, 6
	jmp @B

.insert_at_di_minus_4:
	scasw
.insert_at_di_minus_6:
	sub di, 6
.insert_at_di:
	mov cx, dx
	sub cx, di
	push si
	push di
	mov di, dx		; -> end
	add di, 8		; -> after destination
	mov dx, di		; update -> end
	std			; AMD erratum 109 workaround
	scasw			; -> last word destination
	lea si, [di - 8]	; -> last word source (dx - 2)
	shr cx, 1		; = amount of words
	jcxz @FF
	cmp cx, 20
	ja @FF
@@:
	movsw
	loop @B
@@:
	rep movsw		; move up all following entries
	cld
	pop di
	pop si
	sub si, 4
	movsw			; copy message offset
	movsw			; copy seg offset
	stosw			; store seg value
	lodsw			; skip this field
	movsw			; copy size offset
.next:
	jmp loopprepare

.done:
	xchg dx, di
	xor ax, ax
	stosw			; terminator

	mov si, table_sorted
internaldatarelocation
loop:
	mov di, relocateddata
linkdatarelocation line_out
	lodsw
	test ax, ax
	jz .done
	push si
	mov si, ax
	extcallcall copy_single_counted_string
	pop si
	lodsw
	test ax, ax
	jnz @F
	add si, 4
	push si
	mov si, msg.none
internaldatarelocation
.next_string:
	extcallcall copy_single_counted_string
	pop si
	jmp .next

@@:
	xchg bx, ax
	mov cx, relocateddata + 26
linkdatarelocation line_out
	sub cx, di
	jbe @F
	mov al, 32
	rep stosb
@@:
	mov ax, [bx]
	extcallcall hexword
	push si
	mov si, msg.address.1
internaldatarelocation
	extcallcall copy_single_counted_string
	pop si
	lodsw
	lodsw
	test ax, ax
	jnz @F
	push si
	mov si, msg.nonesize
internaldatarelocation
	jmp .next_string

@@:
	push si
	mov si, msg.size.1
internaldatarelocation
	extcallcall copy_single_counted_string
	xchg bx, ax
	mov ax, [bx]
	extcallcall hexword
	mov si, msg.size.2
internaldatarelocation
	extcallcall copy_single_counted_string
	xor dx, dx
	mov cx, 1
	mov bx, 9
	extcallcall disp_dxax_times_cx_width_bx_size.store
	pop si
.next:
	extcallcall putsline_crlf
	jmp loop

.done:

display_alloc:
	mov dx, msg.alloc
internaldatarelocation
	extcallcall putsz

	mov bx, relocateddata
linkdatarelocation alloc_seg, -2, optional
	test bx, bx
	jnz @F
	mov si, msg.none
.eol_string:
internaldatarelocation
	extcallcall copy_single_counted_string
	jmp .eol

@@:
	mov ax, [bx]
	extcallcall hexword
	mov si, msg.address.1
internaldatarelocation
	extcallcall copy_single_counted_string

	mov bx, relocateddata
linkdatarelocation alloc_size, -2, optional
	test bx, bx
	jnz @F
	mov si, msg.nonesize
internaldatarelocation
	jmp .eol_string

@@:
	mov si, msg.size.1
internaldatarelocation
	extcallcall copy_single_counted_string
	dec di
	mov ax, [bx]
	mov cl, 4
	push ax
	mov dx, ax
	rol ax, cl
	extcallcall hexnyb
	xchg ax, dx
	shl ax, cl
	extcallcall hexword
	mov si, msg.size.2
internaldatarelocation
	extcallcall copy_single_counted_string
	pop ax
	xor dx, dx
	mov cx, 16
	mov bx, 9
	extcallcall disp_dxax_times_cx_width_bx_size.store
.eol:
	extcallcall putsline_crlf

end:
	mov ax, word [cs:eldiEndCode]
internalcoderelocation
	sub ax, word [cs:eldiStartCode]
internalcoderelocation
	sub word [relocateddata], ax
linkdatarelocation extseg_used

	mov ax, word [cs:eldiEndData]
internalcoderelocation
	sub ax, word [cs:eldiStartData]
internalcoderelocation
	sub word [relocateddata], ax
linkdatarelocation extdata_used

	xor ax, ax
	retf

DATAOFFSET equ CODEOFFSET + code_size
	addsection DATA, follows=CODE vstart=8000h
%assign DATASECTION 1
%define DATAFIXUP - datastart + 0
datastart:

	align 8, db 0
table:
.:
	dw msg.entryseg
internaldatarelocation
	dw relocateddata
linkdatarelocation pspdbg, -2, optional
	dw 0
	dw relocateddata
linkdatarelocation entryseg_size, -2, optional

	dw msg.messageseg
internaldatarelocation
	dw relocateddata
linkdatarelocation messageseg, -2, optional
	dw 0
	dw relocateddata
linkdatarelocation messageseg_size, -2, optional

	dw msg.auxbuffseg
internaldatarelocation
	dw relocateddata
linkdatarelocation auxbuff_segment, -2, optional
	dw 0
	dw relocateddata
linkdatarelocation auxbuff_current_size, -2, optional

	dw msg.codeseg
internaldatarelocation
	dw relocateddata
linkdatarelocation code_seg, -2, optional
	dw 0
	dw relocateddata
linkdatarelocation code_size, -2, optional

	dw msg.code2seg
internaldatarelocation
	dw relocateddata
linkdatarelocation code2_seg, -2, optional
	dw 0
	dw relocateddata
linkdatarelocation code2_size, -2, optional

	dw msg.historyseg
internaldatarelocation
	dw relocateddata
linkdatarelocation history_segment, -2, optional
	dw 0
	dw relocateddata
linkdatarelocation historyseg_size, -2, optional

	dw msg.extseg
internaldatarelocation
	dw relocateddata
linkdatarelocation extseg, -2, optional
	dw 0
	dw relocateddata
linkdatarelocation extseg_size, -2, optional
.end:
.amount equ (.end - .) / 8

	dw 0

msg:
.entryseg:	counted "Entry segment: "
.messageseg:	counted "Message segment: "
.codeseg:	counted "First code segment: "
.code2seg:	counted "Second code segment: "
.auxbuffseg:	counted "Auxiliary buffer segment: "
.historyseg:	counted "History segment: "
.extseg:	counted "ELD code segment: "
.none:		counted "None (Segment data not available.)"
.nonesize:	counted "Size data not available."
.address.1:	counted "  "
.size.1:	counted "Size:  "
.size.2:	counted "  "
.alloc:		fill 26, 32, db "Total allocation: "
		asciz

	align 8, db 0
uinit_data:

	align 16, db 0
data_size equ $ - datastart

	absolute uinit_data
table_sorted:
	resb 8 * table.amount + 2

	alignb 16
uinit_data_end:

total_data_size equ $ - datastart
%assign _DATA_SIZE total_data_size

	usesection CODE

%include "eldlink.asm"

	align 16
code_size equ $ - code
